﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.

Sub Init_General
    bmpIcon32 = LoadBitmap(File.DirAssets, "rep_aid32.png")
	bmpIcon64 = LoadBitmap(File.DirAssets, "rep_aid2.png")
End Sub

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private xui As XUI
	Private BC As ByteConverter
	Public bLog As Boolean
	Public lTicksOff As Long
	Public bFromDatePicker As Boolean
	Public bmpIcon32 As Bitmap
	Public bmpIcon64 As Bitmap
	Private lStartTime(10) As Long
	Type tExplainColumns(addr As String, _
					    opcode As String, _
						p1 As Int, _
						p2 As Int, _
						p3 As Int, _
						p4 As String, _
						p5 As String, _
						comment As String)
End Sub

Sub PosInQuotesBytes(iPos As Int, btQuote As Byte, arrBytes() As Byte) As Boolean
	
	Dim i As Int
	Dim iUB As Int
	Dim bQuoteOpen As Boolean
	
	iUB = arrBytes.Length - 1
	
	'this should be avoided in the calling Sub
	'-----------------------------------------
	If iPos > iUB Then
		Return False
	End If
	
	For i = 0 To iUB
		If arrBytes(i) = btQuote Then
			If i = 0 Then
				bQuoteOpen = True
			Else
				If i = iUB Then
					bQuoteOpen = (bQuoteOpen = False)
				Else
					If arrBytes(i + 1) <> btQuote And arrBytes(i - 1) <> btQuote Then
						bQuoteOpen = (bQuoteOpen = False)
					End If
				End If
			End If
		Else
			If i = iPos Then
				Return bQuoteOpen
			End If
		End If
	Next
	
	Return False
	
End Sub

Sub GetComments(strSQL As String) As Map

	'will produce a map with end of comment position as the key (will be unique) and
	'a type (tComment), holding the comment (without any starting or ending characters) and
	'the type of comment and in case of SQL-type comment the ending type: Chr(10) or end of SQL
	'------------------------------------------------------------------------------------------
	Dim i As Int
	Dim n As Int
	Dim arrBytes() As Byte
	Dim iUB As Int
	Dim bHasSingleQuotes As Boolean
	Dim mapComments As Map
	
	mapComments.Initialize
	
	If strSQL.IndexOf("/*") = -1 Then
		If strSQL.IndexOf("*/") = -1 Then
			If strSQL.IndexOf("--") = -1 Then
				Return mapComments
			End If
		End If
	End If

	arrBytes = strSQL.GetBytes("ASCII")
	iUB = arrBytes.Length - 1

	'saves some time and makes debugging simpler if there are no single quotes
	'-------------------------------------------------------------------------
	For i = 0 To iUB
		If arrBytes(i) = 39 Then
			bHasSingleQuotes = True
			Exit
		End If
	Next

	If bHasSingleQuotes Then
		For i = 0 To iUB - 1
			If (arrBytes(i) = 47 And arrBytes(i + 1) = 42) Or _
               (arrBytes(i) = 45 And arrBytes(i + 1) = 45) Then
				If PosInQuotesBytes(i, 39, arrBytes) = False Then
					If arrBytes(i) = 47 Then
						For n = i + 1 To iUB - 1
							If arrBytes(n) = 42 And arrBytes(n + 1) = 47 Then
								If PosInQuotesBytes(n, 39, arrBytes) = False Then
									'C-style comment, starting with /*
									'---------------------------------
									Dim tCmt As tComment
									tCmt.Initialize
									tCmt.strComment = strSQL.SubString2(i + 2, n)
									tCmt.btType = 1
									mapComments.Put(n + 1, tCmt)
									'General.RunLog ("GetComments |" & tCmt.strComment & "| - " & (n + 1))
									i = n
									Exit
								End If
							Else
								If arrBytes(n) = 47 And arrBytes(n + 1) = 42 Then
									i = n
									Exit    'as started a new comment block
								End If
							End If    'If arrBytes(n) = 42 And arrBytes(n + 1) = 47
						Next
					Else    'If arrBytes(i) = 47 Then
						For n = i + 1 To iUB
							If arrBytes(n) = 10 Or n = iUB Then
								If PosInQuotesBytes(n, 39, arrBytes) = False Then
									'SQL-style comment, starting with --
									'-----------------------------------
									If n = iUB Then
										'Comment ended by end of SQL
										'---------------------------
										Dim tCmt As tComment
										tCmt.Initialize
										tCmt.strComment = strSQL.SubString2(i + 2, iUB + 1)
										tCmt.btType = 3
										mapComments.Put(iUB, tCmt)
									Else
										'Comment ended by Chr(10)
										'------------------------
										Dim tCmt As tComment
										tCmt.Initialize
										tCmt.strComment = strSQL.SubString2(i + 2, n)
										tCmt.btType = 2
										mapComments.Put(n - 1, tCmt)    '-1 as we consider Chr(10) not part of the comment
										'General.RunLog ("GetComments |" & tCmt.strComment & "| - " & (n))
									End If
									i = n
									Exit
								End If
							Else
								If arrBytes(n) = 45 And arrBytes(n + 1) = 45 Then
									i = n
									Exit    'as started a new comment block
								End If
							End If    'If arrBytes(n) = 10 Or n = iUB - 1
						Next
					End If    'If arrBytes(i) = 47 Then
				End If    'If PosInQuotesBytes(i, 39, arrBytes) = False
			End If    'If arrBytes(i) = 47 And arrBytes(i + 1) = 42 Or arrBytes(i) = 45 And arrBytes(i + 1) = 45
		Next
	Else    'If bHasSingleQuotes
		For i = 0 To iUB - 1
			If (arrBytes(i) = 47 And arrBytes(i + 1) = 42) Or _
               (arrBytes(i) = 45 And arrBytes(i + 1) = 45) Then
				If arrBytes(i) = 47 Then
					For n = i + 1 To iUB - 1
						If arrBytes(n) = 42 And arrBytes(n + 1) = 47 Then
							'C-style comment, starting with /*
							'---------------------------------
							Dim tCmt As tComment
							tCmt.Initialize
							tCmt.strComment = strSQL.SubString2(i + 2, n)
							tCmt.btType = 1
							mapComments.Put(n + 1, tCmt)
							'General.RunLog ("GetComments |" & tCmt.strComment & "| - " & (n + 1))
							i = n
							Exit
						Else
							If arrBytes(n) = 47 And arrBytes(n + 1) = 42 Then
								i = n
								Exit    'as started a new comment block
							End If
						End If    'If arrBytes(n) = 42 And arrBytes(n + 1) = 47
					Next
				Else    'If arrBytes(i) = 47 Then
					For n = i + 1 To iUB
						If arrBytes(n) = 10 Or n = iUB Then
							'SQL-style comment, starting with --
							'-----------------------------------
							If n = iUB Then
								'Comment ended by end of SQL
								'---------------------------
								Dim tCmt As tComment
								tCmt.Initialize
								tCmt.strComment = strSQL.SubString2(i + 2, iUB + 1)
								tCmt.btType = 3
								mapComments.Put(iUB, tCmt)
								'General.RunLog ("GetComments |" & tCmt.strComment & "| - " & iUB)
							Else
								'Comment ended by Chr(10)
								'------------------------
								Dim tCmt As tComment
								tCmt.Initialize
								tCmt.strComment = strSQL.SubString2(i + 2, n)
								tCmt.btType = 2
								mapComments.Put(n - 1, tCmt)    '-1 as we consider Chr(10) not part of the comment
								'General.RunLog ("GetComments |" & tCmt.strComment & "| - " & (n))
							End If
							i = n    '<<<<<<<<< was + 1, for all i = n
							Exit
						Else
							If arrBytes(n) = 45 And arrBytes(n + 1) = 45 Then
								i = n
								Exit    'as started a new comment block
							End If
						End If
					Next
				End If    'If arrBytes(i) = 47 Then
			End If    'If arrBytes(i) = 47 And arrBytes(i + 1) = 42 Or arrBytes(i) = 45 And arrBytes(i + 1) = 45
		Next

	End If    'If bHasSingleQuotes

	Return mapComments

End Sub

Sub RemoveSQLComments(strSQL As String) As String

	Dim i As Int
	Dim mapSQLComments As Map
	Dim tCmt As tComment
	'---------------------------------------------------------------------------------------------
	'Comments are not SQL commands, but can occur within the text of SQL queries passed to
	'sqlite3_prepare_v2() and related interfaces.
	'Comments are treated as whitespace by the parser.
	'Comments can begin anywhere whitespace can be found, including inside expressions
	'that span multiple lines.

	'SQL comments begin with two consecutive "-" characters (ASCII 0x2d) and extend up to
	'and including the next newline character (ASCII 0x0a) = Chr(10) or until the end of input,
	'whichever comes first.

	'C-style comments begin with "/*" and extend up to and including the next "*/" character pair
	'or until the end of input, whichever comes first. C-style comments can span multiple lines.

	'Comments can appear anywhere whitespace can occur, including inside expressions and
	'in the middle of other SQL statements. Comments do not nest.
	'---------------------------------------------------------------------------------------------
	mapSQLComments = GetComments(strSQL)

	If mapSQLComments.Size = 0 Then
		Return strSQL
	End If

	For i = 0 To mapSQLComments.Size - 1
		tCmt = mapSQLComments.GetValueAt(i)
		If tCmt.btType = 1 Then
			strSQL = strSQL.Replace("/*" & tCmt.strComment & "*/", "")
		Else
			strSQL = strSQL.Replace("--*" & tCmt.strComment, "") 'so we keep the Chr(10)
		End If
	Next

	Return strSQL

End Sub


'INPUT_TYPE_TEXT = 1
'INPUT_TYPE_NUMBERS = 2
'INPUT_TYPE_PHONE = 3
'INPUT_TYPE_DECIMAL_NUMBER = 4
Public Sub GetInputResult(strPrompt As String, _
		  		   		  strTitle As String, _
		  		   		  strPositive As String, _
		  		   		  strCancel As String, _
		  		   		  strNegative As String, _
		  		   		  bHideInput As Boolean, _
				   		  iInputType As Int) As String
	
	Dim IPDialogs As InputDialog
	Dim iIPDialogResult As Int

	IPDialogs.InputType = iInputType
	IPDialogs.PasswordMode = bHideInput
		
	iIPDialogResult = IPDialogs.Show(strPrompt, strTitle, strPositive, strCancel, strNegative, bmpIcon32)
	
	RunLog("GetInputResult, iIPDialogResult: " & iIPDialogResult)
	RunLog("GetInputResult, input result: " & "|" & IPDialogs.Input & "|")
	
	Select Case iIPDialogResult
		Case -3 'OK
			Return IPDialogs.Input
		Case -1 'Cancel
			Return ""
	End Select
	
	Return ""

End Sub

Public Sub Boolean2String(bBoolean As Boolean) As String
	If bBoolean Then
		Return "True"
	Else
		Return "False"
	End If
End Sub

Public Sub Boolean2Int(bBoolean As Boolean) As Int
	If bBoolean Then
		Return 1
	Else
		Return 0
	End If
End Sub

Public Sub RunLog(strLogText As String)
	If bLog Then
		Log(strLogText)
	End If
End Sub

Public Sub CurrentDateMinusX(iDays As Int) As Long
	
	Return Starter.lTodayXLDate - iDays
	
End Sub

Public Sub Ticks2String(lTicks As Long, strFormat As String, bMegaTicks As Boolean) As String
	
	'RunLog("Ticks2String, lTicks: " & lTicks)
	
	If lTicks = 0 Then 'but this could be 01/01/1970 midnight!
		Return ""
	End If
	
	If strFormat.Length = 0 Then
		strFormat = "dd/MMM/yyyy"
	End If
	
	DateTime.DateFormat = strFormat
	
	If bMegaTicks Then
		Return DateTime.Date(lTicks * 1000)
	Else
		Return DateTime.Date(lTicks)
	End If
	
End Sub

Public Sub ExcelDate2String(lXLDate As Long, strFormat As String) As String
	
	Dim ExcelUnixDiff As Long = 25569       'days between Jan 01 1900 and Jan 01 1970
	Dim DaySecs As Long = 86400             'number of seconds in a day
	Dim lVal As Long
	
	If lXLDate < 1 Then
		Return ""
	End If
	
	'RunLog("ExcelDate2String, lXLDate: " & lXLDate)
	
	If strFormat.Length = 0 Then
		strFormat = "dd/MMM/yyyy"
	End If
	
	lVal = (lXLDate - ExcelUnixDiff) * DaySecs
	lVal = DateUtils.UnixTimeToTicks(lVal)
	DateTime.DateFormat = strFormat
	Return(DateTime.Date(lVal))
	
End Sub

Public Sub Ticks2ExcelDate(lTicks As Long) As Long
	Return 25569 + ((lTicks - lTicksOff) / 86400000)
End Sub

Public Sub ExcelDate2Ticks(lExcelDate As Long) As Long
	Return (lExcelDate - 25569) * 86400000 + lTicksOff
End Sub

Public Sub ExcelDate2Age(lExcelDate As Long) As Long
	
	Dim lTicks As Long
	Dim lYear As Long
	Dim lMonth As Long
	Dim lDay As Long
	Dim lAge As Long
	
	lTicks = ExcelDate2Ticks(lExcelDate)
	lYear = DateTime.GetYear(lTicks)
	lMonth = DateTime.GetMonth(lTicks)
	lAge = Starter.lTodayYear - lYear
	
	If Starter.lTodayMonth < lMonth Then
		lAge = lAge - 1
	Else
		If Starter.lTodayMonth = lMonth Then
			lDay = DateTime.GetDayOfMonth(lTicks)
			If lDay > Starter.lTodayDay Then
				lAge = lAge - 1
			End If
		End If
	End If
	
	Return lAge

End Sub

Public Sub ExcelDate2StringAge(lExcelDate As Long) As String
	
	Dim lTicks As Long
	Dim lYear As Long
	Dim lMonth As Long
	Dim lDay As Long
	Dim lAge As Long
	Dim lDays As Long
	Dim strAge As String
	
	lTicks = ExcelDate2Ticks(lExcelDate)
	lYear = DateTime.GetYear(lTicks)
	lMonth = DateTime.GetMonth(lTicks)
	lDay = DateTime.GetDayOfMonth(lTicks)
	lAge = Starter.lTodayYear - lYear
	
	If lMonth > Starter.lTodayMonth Then
		lAge = lAge - 1
	Else
		If Starter.lTodayMonth = lMonth Then
			RunLog("ExcelDate2StringAge, lDay: " & lDay)
			RunLog("ExcelDate2StringAge, Starter.lTodayDay: " & Starter.lTodayDay)
			If lDay > Starter.lTodayDay Then
				lAge = lAge - 1
			End If
		End If
	End If
	
	lDays = Starter.lTodayXLDate - lExcelDate

	RunLog("ExcelDate2StringAge, lDays: " & lDays)
	
	If lAge < 1 Then
		If lDays < 14 Then 'so days up to 13 days then weeks
			Return (lDays) & " days"
		Else
			If lDays < 91 Then 'so weeeks up to 12 weeks then months
				Return (CInt((lDays) / 7)) & " weeks"
			Else
				If Starter.lTodayMonth > lMonth Then
					If lDay > Starter.lTodayDay Then
						Return ((Starter.lTodayMonth - lMonth) - 1) & " months"	
					Else
						Return (Starter.lTodayMonth - lMonth) & " months"
					End If
				Else
					If lMonth = Starter.lTodayMonth Then
						Return "11 months"
					Else
						If lDay > Starter.lTodayDay Then
							Return ((Starter.lTodayMonth + (12 - lMonth)) - 1) & " months"
						Else
							Return (Starter.lTodayMonth + (12 - lMonth)) & " months"
						End If
					End If
				End If
			End If
		End If
	Else
		strAge = lAge
		Return strAge
	End If
	

End Sub

Sub CInt(o As Object) As Int
	Return Floor(o)
End Sub


Public Sub ExcelDate2Month(lExcelDate As Long) As Int
	
	Return DateTime.GetMonth(ExcelDate2Ticks(lExcelDate))
	
End Sub

Public Sub SQL_IN_FROMLIST(oMap As Map) As String
	
	Dim i As Int
	Dim str As String
	
	str = "("
	For i = 0 To oMap.Size - 1
		If i > 0 Then
			str = str & ", " & oMap.GetKeyAt(i)
		Else
			str = str & oMap.GetKeyAt(i)
		End If
	Next
	str = str & ")"
	
	Return str
	
End Sub

Public Sub GetSDPath() As String
	
	Dim de As String = File.DirRootExternal
	
	RunLog("DirRootExternal = "&de)
	
	Dim mtc As Matcher = Regex.Matcher("(/|\\)[^(/|\\)]*(/|\\)",de)
	Dim extsdcard As String = de
	
	If mtc.Find = True Then
		Dim mnt As String = mtc.Group(0)
       
		RunLog("mount point = "& mnt)
		Dim dirs As List = File.ListFiles(mnt)
		For Each f As String In dirs
			RunLog("Device = "& f)
			If f.ToLowerCase.Contains("extsdcard") Then
				extsdcard = mnt&f
				Return extsdcard
			End If
		Next
	End If
	
	RunLog("extsdcard="&extsdcard)
	For Each f As String In File.ListFiles(extsdcard)
		RunLog(">"&f)
	Next
	
	Return ""
	
End Sub

Sub MakeString(btByte As Byte, lNum As Long) As String
	
	Dim i As Long
	Dim arrBytes(lNum) As Byte
	
	For i = 0 To lNum - 1
		arrBytes(i) = btByte
	Next
	
	Return BC.StringFromBytes(arrBytes, "ASCII")

End Sub

Sub MakeString2(strString As String, lNum As Long) As String
	
	Dim i As Long
	Dim n As Long
	Dim arrBytesString() As Byte
	Dim arrBytes(lNum * strString.Length) As Byte
	Dim iStringBytes As Int
	
	Dim str As String = "A" & CRLF & "A" & CRLF
	Dim arrB() As Byte
	
	arrB = str.GetBytes("ASCII")
	For i = 0 To arrB.Length - 1
		RunLog("Test byte: " & arrB(i))
	Next
	
	iStringBytes = strString.Length
	
	arrBytesString = strString.GetBytes("ASCII")
	
	For i = 0 To arrBytes.Length - 1 Step iStringBytes
		For n = 0 To iStringBytes - 1
			arrBytes(i + n) = arrBytesString(n)
			RunLog("MakeString2, Pos: " & (i + n) & ", Byte: " & arrBytesString(n))
		Next
	Next
	
	Return BC.StringFromBytes(arrBytes, "ASCII")

End Sub

Private Sub CStr(o As Object) As String
	Return "" & o
End Sub

Private Sub SubCharSequence2(oCS As CSBuilder, iBeginIndex As Int, iEndIndex As Int) As CSBuilder
	
	Dim JObj As JavaObject
	
	JObj = oCS
	
	'General.RunLog("SubCharSequence2, iBeginIndex: " & iBeginIndex & ", iEndIndex: " & iEndIndex)
	
	Return JObj.RunMethod ("subSequence", Array (iBeginIndex, iEndIndex))

End Sub

'Will produce a 2D Long array with:
'in column 0: the index of the first character of the line
'in column 1: the index of the last character of the line
Sub GetLineMarkers(strText As String) As Long(,)

    Dim i As Long
    Dim n As Long
    Dim bStart As Boolean
    Dim arrBytes() As Byte
	Dim lUB As Long

    arrBytes = strText.GetBytes("ASCII")
	lUB = arrBytes.Length - 1

    Dim arrMarkers(lUB / 2, 2) As Long

    For i = 0 To lUB
        If arrBytes(i) = 10 Or i = lUB Then
            If bStart Then
                If i = lUB Then
                    arrMarkers(n, 1) = i  'index of last char of line
                    n = n + 1
                Else
					arrMarkers(n, 1) = i - 1  'index of last char of line
                    n = n + 1
                    bStart = False
                End If
            End If
        Else
            If bStart = False Then
                bStart = True
				arrMarkers(n, 0) = i  'index of first char of line
            End If
        End If
    Next

    Dim arrMarkers2(n, 2) As Long

    For i = 0 To n - 1
        arrMarkers2(i, 0) = arrMarkers(i, 0)
        arrMarkers2(i, 1) = arrMarkers(i, 1)
    Next

    Return arrMarkers2

End Sub

'this will also deal with a string or csBuilder text with line breaks
Sub GetTextWidth(oParent As Activity, strText As String, iTextSize As Int, CSB As CSBuilder, iHorizontalPadding As Int) As Float
	
	'so we can measure text width without passing a view
	'---------------------------------------------------
	Dim i As Long
	Dim btn As Button
	Dim cvs As Canvas
	Dim strTextCSB As String
	Dim fStringWidth As Float
	Dim fStringWidthLine As Float
	Dim arrLineMarkers(,) As Long
	Dim bHasLinebreak As Boolean 'so we can get the width of the longest line
	Dim strLine As String
	Dim csbLine As CSBuilder
	
	If CSB.IsInitialized Then
		strTextCSB = CSB.ToString
		bHasLinebreak = strTextCSB.IndexOf(Chr(10)) > -1
	Else
		bHasLinebreak = strText.IndexOf(Chr(10)) > -1
	End If
	 
	RunLog("GetTextWidth, bHasLinebreak: " & Boolean2String(bHasLinebreak))
	
	btn.Initialize("")
	btn.Padding = Array As Int(iHorizontalPadding * 1dip, 0, iHorizontalPadding * 1dip, 0)
	Dim xbtn As B4XView = btn
	
	xbtn.Font = xui.CreateDefaultFont(iTextSize)
	oParent.AddView(btn, 10dip, 10dip, 80dip, 40dip)

	cvs.Initialize(btn)
	
	If CSB.IsInitialized Then
		If bHasLinebreak Then
			arrLineMarkers = GetLineMarkers(strTextCSB)
			For i = 0 To arrLineMarkers.Length - 1
				csbLine = SubCharSequence2(CSB,arrLineMarkers(i, 0), arrLineMarkers(i, 1) + 1)
				xbtn.Text = csbLine
				fStringWidthLine = cvs.MeasureStringWidth(csbLine, btn.Typeface, iTextSize)
				RunLog("GetTextWidth, csbLine. : " & csbLine.ToString & ", fStringWidthLine: " & fStringWidthLine)
				If fStringWidthLine > fStringWidth Then
					fStringWidth = fStringWidthLine
				End If
			Next
		Else
			xbtn.Text = CSB
			fStringWidth =  cvs.MeasureStringWidth(CSB, btn.Typeface, iTextSize)
		End If
	Else
		If bHasLinebreak Then
			arrLineMarkers = GetLineMarkers(strText)
			For i = 0 To arrLineMarkers.Length - 1
				strLine = strText.SubString2(arrLineMarkers(i, 0), arrLineMarkers(i, 1) + 1)
				xbtn.Text = strLine
				fStringWidthLine = cvs.MeasureStringWidth(strLine, btn.Typeface, iTextSize)
				If fStringWidthLine > fStringWidth Then
					fStringWidth = fStringWidthLine
				End If
			Next
		Else
			xbtn.Text = strText
			fStringWidth =  cvs.MeasureStringWidth(strText, btn.Typeface, iTextSize)
		End If
	End If
	
	btn.RemoveView
	
	Return fStringWidth

End Sub

Sub GetButtonTextWidth(oButton As B4XView) As Float
	
	Dim cvs As Canvas
	Dim btn As Button
	
	btn = oButton
	
	cvs.Initialize(oButton)
	
	Return cvs.MeasureStringWidth(oButton.Text, btn.Typeface, btn.TextSize)

End Sub

Sub SetCursorVisible(edt As EditText, Visible As Boolean)
	Dim jo = edt As JavaObject
	jo.RunMethod("setCursorVisible", Array As Object(Visible))
End Sub

Sub GetErrorString() As String
	
	Dim strError As String
	Dim iPos As Int

	If LastException.IsInitialized = False Then
		Return "No error"
	Else
		strError = LastException.Message
		RunLog("GetErrorString, strError: " & strError)
		iPos = strError.IndexOf("###")
		If iPos > -1 And iPos < strError.Length - 1 Then
			strError = strError.SubString2(0, iPos)
		End If
	End If
	
	Return strError

End Sub

Public Sub StartSW(iIndex As Int)
	lStartTime(iIndex) = DateTime.Now
End Sub

Public Sub StopSW(iIndex As Int) As Long
	Return DateTime.Now - lStartTime(iIndex)
End Sub